/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.5 by edhill, Wed Aug 27 22:12:31 2003 UTC revision 1.30 by edhill, Tue Nov 11 21:11:06 2003 UTC
# Line 8  Line 8 
8  #   modified by aja 01/00  #   modified by aja 01/00
9  #   rewritten in bash by eh3 08/03  #   rewritten in bash by eh3 08/03
10    
11    # Search for particular CPP #cmds associated with packages
12    # usage: test_for_package_in_cpp_options CPP_file package_name
13    test_for_package_in_cpp_options() {
14        cpp_options=$1
15        pkg=$2
16        grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
17        RETVAL=$?
18        if test "x${RETVAL}" = x0 ; then
19            echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"
20            exit 99
21        fi
22        grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
23        RETVAL=$?
24        if test "x${RETVAL}" = x0 ; then
25            echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"
26            exit 99
27        fi
28        grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
29        RETVAL=$?
30        if test "x${RETVAL}" = x0 ; then
31            echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"
32            exit 99
33        fi
34        grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
35        RETVAL=$?
36        if test "x${RETVAL}" = x0 ; then
37            echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"
38            exit 99
39       fi
40    }
41    
42    # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
43    # the package list.
44    expand_pkg_groups() {
45        new_packages=
46        PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
47        if test -r $PKG_GROUPS ; then
48            cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
49            cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
50            matched=0
51            for i in $PACKAGES ; do
52                line=`grep "^ *$i" ./p2.tmp`
53                RETVAL=$?
54                if test "x$RETVAL" = x0 ; then
55                    matched=1
56                    replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
57                    echo "    replacing \"$i\" with: $replace"
58                    new_packages="$new_packages $replace"
59                else
60                    new_packages="$new_packages $i"
61                fi
62            done
63            PACKAGES=$new_packages
64            rm -f ./p[1,2].tmp
65        else
66            echo "Warning: can't read package groups definition file: $PKG_GROUPS"
67        fi
68    }
69    
70  # Guess possible config options for this host  # Guess possible config options for this host
71  find_possible_configs()  {  find_possible_configs()  {
72    
73      p_PLATFORM=`uname`"-"`uname -m`      tmp1=`uname`"_"`uname -m`
74      echo "The platform appears to be:"      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
75      echo "  "$p_PLATFORM      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
76        PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
77      p_LN=      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
78        echo "  The platform appears to be:  $PLATFORM"
79    #     if test "x$OFLIST" = x ; then
80    #       echo "  No pre-defined options files were found matching this platform"
81    #       echo "  but examples for other platforms can be found in:"
82    #       echo "    $ROOTDIR/tools/build_options"
83    #     else
84    #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"
85    #       echo "  may work with this machine are:"
86    #       for i in $OFLIST ; do
87    #           echo "    $i"
88    #       done
89    #     fi
90        
91      echo "test" > test      echo "test" > test
92      ln -s ./test link      ln -s ./test link
93      RETVAL=$?      RETVAL=$?
94      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
95          p_LN="ln -s"          LN="ln -s"
96        else
97            echo "Error: \"ln -s\" does not appear to work on this system!"
98            echo "  For help, please contact <MITgcm-support@mitgcm.org>."
99            exit 1
100      fi      fi
101      rm -f test link      rm -f test link
102    
103      p_CPP=`which cpp`      if test "x$CPP" = x ; then
104                CPP="cpp -traditional -P"
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         p_LN="ln -s"  
105      fi      fi
     rm -f test link  
106    
107      # look for possible fortran compilers      # look for possible fortran compilers
108        tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
109      p_FC=      p_FC=
110      for c in f77 g77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 ; do      for c in $tmp ; do
111          which $c > /dev/null 2>&1          rm -f ./hello.f ./hello
112            cat >> hello.f <<EOF
113          program hello
114          do i=1,3
115            print *, 'hello world : ', i
116          enddo
117          end
118    EOF
119            $c -o hello hello.f > /dev/null 2>&1
120          RETVAL=$?          RETVAL=$?
121          if test "x${RETVAL}" = x0 ; then          if test "x${RETVAL}" = x0 ; then
122              p_FC="$p_FC $c"              p_FC="$p_FC $c"
123          fi          fi
124      done      done
125      echo "Possible FORTRAN compilers appear to be:  "      rm -f ./hello.f ./hello
126      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
127          echo "  None found!!!"          cat 1>&2 <<EOF
128    
129    Error: No Fortran compilers were found in your path.  Please specify one using:
130    
131        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
132        2) a command-line option (eg. "-fc NAME"), or
133        3) the MITGCM_FC environment variable.
134    
135    EOF
136            exit 1
137      else      else
138          echo "  "$p_FC          echo "  The possible FORTRAN compilers found in your path are:"
139            echo "   "$p_FC
140            if test "x$FC" = x ; then
141                FC=`echo $p_FC | $AWK '{print $1}'`
142            fi
143      fi      fi
144    
145      # look for possible MPI libraries      for i in $p_FC ; do
146      mpi_libs=          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
147      mpi_fort=`which mpif77 2>/dev/null`          if test -r $p_OF ; then
148      RETVAL=$?              OPTFILE=$p_OF
149      if test "x${RETVAL}" = x0 ; then              echo "  The options file:  $p_OF"
150          cat >>test.f <<EOF              echo "    appears to match so we'll use it."
151        PROGRAM HELLO              break
       DO 10, I=1,10  
       PRINT *,'Hello World'  
    10 CONTINUE  
       STOP  
       END  
 EOF  
         eval "$mpi_fort -showme test.f > out"  
         RETVAL=$?  
         if test "x${RETVAL}" = x0 ; then  
             a=`cat out`  
             for i in $a ; do  
                 case $i in  
                     -*)  
                         mpi_libs="$mpi_libs $i" ;;  
                 esac  
             done  
             echo "The MPI libs appear to be:"  
             echo "  "$mpi_libs  
152          fi          fi
153          rm -f test.f out      done
154        if test "x$OPTFILE" = x ; then
155            cat 1>&2 <<EOF
156    
157    Error: No options file was found in:  $ROOTDIR/tools/build_options/
158      that matches this platform ("$PLATFORM") and the compilers found in
159      your path.  Please specify an "optfile" using:
160    
161        1) the command line (eg. "-optfile=path/to/OPTFILE"), or
162        2) the MITGCM_OF environment variable.
163    
164      If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
165    
166    EOF
167            exit 1
168      fi      fi
169        
170    #     # look for possible MPI libraries
171    #     mpi_libs=
172    #     mpi_fort=`which mpif77 2>/dev/null`
173    #     RETVAL=$?
174    #     if test "x${RETVAL}" = x0 ; then
175    #       cat >>test.f <<EOF
176    #       PROGRAM HELLO
177    #       DO 10, I=1,10
178    #       PRINT *,'Hello World'
179    #    10 CONTINUE
180    #       STOP
181    #       END
182    # EOF
183    #       eval "$mpi_fort -showme test.f > out"
184    #       RETVAL=$?
185    #       if test "x${RETVAL}" = x0 ; then
186    #           a=`cat out`
187    #           for i in $a ; do
188    #               case $i in
189    #                   -*)
190    #                       mpi_libs="$mpi_libs $i" ;;
191    #               esac
192    #           done
193    #           echo "The MPI libs appear to be:"
194    #           echo "  "$mpi_libs
195    #       fi
196    #       rm -f test.f out
197    #     fi
198    
199  }  }
200    
# Line 86  get_pdepend_list()  { Line 204  get_pdepend_list()  {
204      #  strip the comments and then convert the dependency file into      #  strip the comments and then convert the dependency file into
205      #  two arrays: PNAME, DNAME      #  two arrays: PNAME, DNAME
206      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
207          | awk 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
208          > ./.pd_tmp          > ./.pd_tmp
209      source ./.pd_tmp      source ./.pd_tmp
210      rm -f ./.pd_tmp      rm -f ./.pd_tmp
# Line 109  usage()  { Line 227  usage()  {
227      echo "      -pdepend=NAME | --pdepend=NAME"      echo "      -pdepend=NAME | --pdepend=NAME"
228      echo "    -pdefault NAME | --pdefault NAME"      echo "    -pdefault NAME | --pdefault NAME"
229      echo "      -pdefault=NAME | --pdefault=NAME"      echo "      -pdefault=NAME | --pdefault=NAME"
230      echo "    -makefile NAME | -ma NAME"      echo "    -make NAME | -m NAME"
231      echo "      --makefile=NAME | -ma=NAME"      echo "      --make=NAME | -m=NAME"
232        echo "    -makefile NAME | -mf NAME"
233        echo "      --makefile=NAME | -mf=NAME"
234      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"
235      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"
236      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"
# Line 121  usage()  { Line 241  usage()  {
241      echo "      -disable=NAME | --disable=NAME"      echo "      -disable=NAME | --disable=NAME"
242      echo "    -enable NAME | --enable NAME"      echo "    -enable NAME | --enable NAME"
243      echo "      -enable=NAME | --enable=NAME"      echo "      -enable=NAME | --enable=NAME"
244        echo "    -standarddirs NAME | --standarddirs NAME"
245        echo "      -standarddirs=NAME | --standarddirs=NAME"
246      echo "    -noopt NAME | --noopt NAME"      echo "    -noopt NAME | --noopt NAME"
247      echo "      -noopt=NAME | --noopt=NAME"      echo "      -noopt=NAME | --noopt=NAME"
248  #    echo "    -cpp NAME | --cpp NAME"  #    echo "    -cpp NAME | --cpp NAME"
# Line 170  S64= Line 292  S64=
292  KPP=  KPP=
293  FC=  FC=
294  LINK=  LINK=
295    DEFINES="-DWORDLENGTH=4"
296  PACKAGES=  PACKAGES=
297  ENABLE=  ENABLE=
298  DISABLE=  DISABLE=
299  MAKEFILE=  MAKEFILE=
300  MAKEDEPEND=  MAKEDEPEND=
301  PDEPEND=  PDEPEND=
302  DUMPSTATE=f  DUMPSTATE=t
303  PDEFAULT=  PDEFAULT=
304  OPTFILE=  OPTFILE=
305  INCLUDES="-I."  INCLUDES="-I."
# Line 190  KPPFILES= Line 313  KPPFILES=
313  NOOPTFILES=  NOOPTFILES=
314  NOOPTFLAGS=  NOOPTFLAGS=
315    
316    # DEFINES checked by test compilation
317    HAVE_SYSTEM=
318    HAVE_FDATE=
319    FC_NAMEMANGLE=
320    
321  MODS=  MODS=
322  TOOLSDIR=  TOOLSDIR=
323  SOURCEDIRS=  SOURCEDIRS=
324  INCLUDEDIRS=  INCLUDEDIRS=
325    STANDARDDIRS=
326    
327  PWD=`pwd`  PWD=`pwd`
328  MAKE=make  MAKE=make
329    AWK=awk
330  THISHOSTNAME=`hostname`  THISHOSTNAME=`hostname`
331  THISCWD=`pwd`  THISCWD=`pwd`
332  THISDATE=`date`  THISDATE=`date`
333  MACHINE=`uname -a`  MACHINE=`uname -a`
334    EXECUTABLE=
335    EXEHOOK=
336    EXEDIR=
337    PACKAGES_CONF=
338    IEEE=
339    if test "x$MITGCM_IEEE" != x ; then
340        IEEE=$MITGCM_IEEE
341    fi
342    
343    AUTODIFF_PKG_USED=f
344    AD_OPTFILE=
345    TAF=
346    AD_TAF_FLAGS=
347    FTL_TAF_FLAGS=
348    SVD_TAF_FLAGS=
349    TAF_EXTRA=
350    TAMC=
351    AD_TAMC_FLAGS=
352    FTL_TAF_FLAGS=
353    SVD_TAMC_FLAGS=
354    TAMC_EXTRA=
355    
356    
357  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
358  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"
359  gm_s2="FC IEEE MPI JAM DUMPSTATE"  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
360    
361  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
362  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
363  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
364  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
365    gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
366    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"
367    
368    #  The following are all related to adjoint/tangent-linear stuff
369    gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
370    gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
371    gm_s12="TAF_EXTRA TAMC_EXTRA"
372    
373  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
374    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
375    
376    
377  echo  echo
378  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
379  gm_local="./gm_local"  gm_local="genmake_local"
380    for i in . $MODS ; do
381        if test -r $i/$gm_local ; then
382            source $i/$gm_local
383            break
384        fi
385    done
386  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
387  if test -e $gm_local ; then  if test -e $gm_local ; then
388      echo "using $gm_local"      echo "using $gm_local"
# Line 238  fi Line 404  fi
404  #   n=$(( $n + 1 ))  #   n=$(( $n + 1 ))
405  #done  #done
406  #parse_options  #parse_options
   
407  ac_prev=  ac_prev=
408  for ac_option ; do  for ac_option ; do
409    
# Line 263  for ac_option ; do Line 428  for ac_option ; do
428          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
429              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
430                    
431            -adoptfile | --adoptfile | -ad | --ad)
432                ac_prev=AD_OPTFILE ;;
433            -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
434                AD_OPTFILE=$ac_optarg ;;
435            
436          -pdepend | --pdepend)          -pdepend | --pdepend)
437              ac_prev=PDEPEND ;;              ac_prev=PDEPEND ;;
438          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
# Line 273  for ac_option ; do Line 443  for ac_option ; do
443          -pdefault=* | --pdefault=*)          -pdefault=* | --pdefault=*)
444              PDEFAULT=$ac_optarg ;;              PDEFAULT=$ac_optarg ;;
445                    
446          -makefile | -ma)          -make | --make | -m | --m)
447                ac_prev=MAKE ;;
448            -make=* | --make=* | -m=* | --m=*)
449                MAKE=$ac_optarg ;;
450            
451            -makefile | --makefile | -ma | --ma)
452              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
453          --makefile=* | -ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
454              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
455                    
456          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl)
# Line 303  for ac_option ; do Line 478  for ac_option ; do
478          -enable=* | --enable=*)          -enable=* | --enable=*)
479              ENABLE=$ac_optarg ;;              ENABLE=$ac_optarg ;;
480                    
481            -standarddirs | --standarddirs)
482                ac_prev=STANDARDDIRS ;;
483            -standarddirs=* | --standarddirs=*)
484                STANDARDDIRS=$ac_optarg ;;
485    
486          -noopt | --noopt)          -noopt | --noopt)
487              ac_prev=NOOPT ;;              ac_prev=NOOPT ;;
488          -noopt=* | --noopt=*)          -noopt=* | --noopt=*)
# Line 319  for ac_option ; do Line 499  for ac_option ; do
499              FC=$ac_optarg ;;              FC=$ac_optarg ;;
500                    
501          -ieee | --ieee)          -ieee | --ieee)
502              IEEE=1 ;;              IEEE=true ;;
503          -noieee | --noieee)          -noieee | --noieee)
504              IEEE=0 ;;              IEEE= ;;
505                    
506          -mpi | --mpi)          -mpi | --mpi)
507              MPI=1 ;;              MPI=true ;;
508          -nompi | --nompi)          -nompi | --nompi)
509              MPI=0 ;;              MPI= ;;
510                    
511          -jam | --jam)          -jam | --jam)
512              JAM=1 ;;              JAM=1 ;;
# Line 336  for ac_option ; do Line 516  for ac_option ; do
516          -ds | --ds)          -ds | --ds)
517              DUMPSTATE=t ;;              DUMPSTATE=t ;;
518                    
519            -taf_extra | --taf_extra)
520                ac_prev=TAF_EXTRA ;;
521            -taf_extra=* | --taf_extra=*)
522                TAF_EXTRA=$ac_optarg ;;
523    
524            -tamc_extra | --tamc_extra)
525                ac_prev=TAMC_EXTRA ;;
526            -tamc_extra=* | --tamc_extra=*)
527                TAMC_EXTRA=$ac_optarg ;;
528    
529          -*)          -*)
530              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
531              usage              usage
# Line 350  for ac_option ; do Line 540  for ac_option ; do
540            
541  done  done
542    
543    if test -f ./.genmakerc ; then
544        echo
545        echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
546        echo "  file.  This file format is no longer supported.  Please see:"
547        echo
548        echo "    http://mitgcm.org/devel_HOWTO/"
549        echo
550        echo "  for directions on how to setup and use the new \"genmake2\" input"
551        echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."
552        echo
553    fi
554    
555    if test "x${ROOTDIR}" = x ; then
556        if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
557            ROOTDIR=".."
558        else
559            for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
560                if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
561                    ROOTDIR=$d
562                    echo -n "Warning:  ROOTDIR was not specified but there appears to be"
563                    echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
564                    break
565                fi
566            done
567        fi
568    fi
569    if test "x${ROOTDIR}" = x ; then
570        echo "Error: Cannot determine ROOTDIR for MITgcm code."
571        echo "  Please specify a ROOTDIR using either an options "
572        echo "  file or a command-line option."
573        exit 1
574    fi
575    if test ! -d ${ROOTDIR} ; then
576        echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
577        exit 1
578    fi
579    
580  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
581  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
582      echo "Warning: no OPTFILE specified so we'll look for possible settings"      if test "x$MITGCM_OF" = x ; then
583      printf "\n===  Searching for possible settings for OPTFILE  ===\n"          echo "Warning: no OPTFILE specified so we'll look for possible settings"
584      find_possible_configs          printf "\n===  Searching for possible settings for OPTFILE  ===\n"
585  else          find_possible_configs
     if test "x$OPTFILE" = xNONE ; then  
         echo "    OPTFILE=NONE so we'll try to use default settings"  
586      else      else
587          if test -f "$OPTFILE" -a -r "$OPTFILE" ; then          OPTFILE=$MITGCM_OF
588              echo "    using OPTFILE=\"$OPTFILE\""      fi
589              source "$OPTFILE"  fi
590              RETVAL=$?  if test "x$OPTFILE" != xNONE ; then
591              if test "x$RETVAL" != x0 ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
592                  echo -n "Error: failed to source OPTFILE \"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
593                  echo "--please check that variable syntax is bash-compatible"          source "$OPTFILE"
594                  exit 1          RETVAL=$?
595              fi          if test "x$RETVAL" != x0 ; then
596              if test "x$DUMPSTATE" != xf ; then              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
597                  cp -f $OPTFILE "gm_optfile"              echo "--please check that variable syntax is bash-compatible"
             fi  
         else  
             echo "Error: can't read OPTFILE=\"$OPTFILE\""  
598              exit 1              exit 1
599          fi          fi
600            if test "x$DUMPSTATE" != xf ; then
601                cp -f $OPTFILE "genmake_optfile"
602            fi
603        else
604            echo "Error: can't read OPTFILE=\"$OPTFILE\""
605            exit 1
606      fi      fi
607  fi  fi
608    
609    echo "  getting AD_OPTFILE information:  "
610    if test "x${AD_OPTFILE}" = x ; then
611        if test "x$MITGCM_AD_OF" = x ; then
612            AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
613        else
614            AD_OPTFILE=$MITGCM_AD_OF
615        fi
616    fi
617    if test "x${AD_OPTFILE}" != xNONE ; then
618        if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
619            echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
620            source "$AD_OPTFILE"
621            RETVAL=$?
622            if test "x$RETVAL" != x0 ; then
623                echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
624                echo "--please check that variable syntax is bash-compatible"
625                exit 1
626            fi
627            if test "x$DUMPSTATE" != xf ; then
628                cp -f $AD_OPTFILE "genmake_ad_optfile"
629            fi
630        else
631            echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
632            exit 1
633        fi
634    fi
635    
636    #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain
637    #  and abort!
638    if test "x$FC" = x ; then
639        cat <<EOF 1>&2
640    
641    Error: no Fortran compiler: please specify using one of the following:
642      1) within the options file ("FC=...") as specified by "-of=OPTFILE"
643      2) the "-fc=XXX" command-line option
644      3) the "./genmake_local" file
645    EOF
646        exit 1
647    fi
648    if test "x$LINK" = x ; then
649        LINK=$FC
650    fi
651    if test "x$CPP" = x ; then
652        CPP="cpp"
653    fi
654    echo "#define A a" | $CPP > test_cpp 2>&1
655    RETVAL=$?
656    if test "x$RETVAL" != x0 ; then
657        cat <<EOF 1>&2
658    
659    Error: C pre-processor "$CPP" failed the test case: please specify using:
660    
661      1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
662      2) the "./genmake_local" file
663      3) with the CPP environment variable
664    
665    EOF
666        exit 1
667    else
668        rm -f test_cpp
669    fi
670    if test "x$MAKEDEPEND" = x ; then
671        MAKEDEPEND=makedepend
672    fi
673    
674    
675    printf "\n===  Checking system libraries  ===\n"
676    echo -n "  Do we have the system() command using $FC...  "
677    cat > genmake_tcomp.f <<EOF
678          program hello
679          call system('echo hi')
680          end
681    EOF
682    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
683    RETVAL=$?
684    if test "x$RETVAL" = x0 ; then
685        HAVE_SYSTEM=t
686        DEFINES="$DEFINES -DHAVE_SYSTEM"
687        echo "yes"
688    else
689        HAVE_SYSTEM=
690        echo "no"
691    fi
692    rm -f genmake_tcomp*
693    
694    echo -n "  Do we have the fdate() command using $FC...  "
695    cat > genmake_tcomp.f <<EOF
696          program hello
697          CHARACTER(128) string
698          string = ' '
699          call fdate( string )
700          print *, string
701          end
702    EOF
703    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
704    RETVAL=$?
705    if test "x$RETVAL" = x0 ; then
706        HAVE_FDATE=t
707        DEFINES="$DEFINES -DHAVE_FDATE"
708        echo "yes"
709    else
710        HAVE_FDATE=
711        echo "no"
712    fi
713    rm -f genmake_tcomp*
714    
715    echo -n "  The name mangling convention for $FC is...  "
716    if test "x$FC_NAMEMANGLE" = x ; then
717        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) X ## _"
718    fi
719    cat > genmake_tcomp.f <<EOF
720          subroutine tcall( string )
721          character*(*) string
722          call tsub( string )
723          end
724    EOF
725    $FC $FFLAGS $DEFINES -c genmake_tcomp.f > genmake_tcomp.log 2>&1
726    RETVAL=$?
727    if test "x$RETVAL" != x0 ; then
728        cat genmake_tcomp.log >> genmake_errors
729        echo
730        echo "WARNING: test compile fails -- please see \"genmake_errors\""
731        echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
732        echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
733    else
734        tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`
735        RETVAL=$?
736        if test "x$RETVAL" != x0 ; then
737            echo
738            echo "WARNING: The \"nm\" command failed."
739            echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
740            echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
741        else
742            t0=`echo $tcall | sed -e 's|_tcall|_ ## X|g'`
743            nmres=`echo $t0 | sed -e 's|tcall_|X ## _|g'`
744            FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmres"
745            echo "'$FC_NAMEMANGLE'"
746        fi
747    fi
748    echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template
749    cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1
750    RETVAL=$?
751    if test "x$RETVAL" != x0 ; then
752        mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h
753    fi
754    rm -f genmake_tcomp*
755    
756    
757  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
758  echo -n "  Adding MODS directories:  "  echo -n "  Adding MODS directories:  "
759  for d in $MODS ; do  for d in $MODS ; do
# Line 400  if test "x${PLATFORM}" = x ; then Line 776  if test "x${PLATFORM}" = x ; then
776      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
777  fi  fi
778    
 if test "x${ROOTDIR}" = x ; then  
     if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then  
         ROOTDIR=".."  
     else  
         for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do  
             if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then  
                 ROOTDIR=$d  
                 echo -n "Warning:  ROOTDIR was not specified but there appears to be"  
                 echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."  
                 break  
             fi  
         done  
     fi  
 fi  
 if test "x${ROOTDIR}" = x ; then  
     echo "Error: Cannot determine ROOTDIR for MITgcm code."  
     echo "  Please specify a ROOTDIR using either an options "  
     echo "  file or a command-line option."  
     exit 1  
 fi  
 if test ! -d ${ROOTDIR} ; then  
     echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"  
     exit 1  
 fi  
   
779  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
780      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then
781          EXEDIR=../exe          EXEDIR=../exe
# Line 444  if test ! -d ${TOOLSDIR} ; then Line 795  if test ! -d ${TOOLSDIR} ; then
795      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"
796      exit 1      exit 1
797  fi  fi
798    if test "x$S64" = x ; then
799        S64='$(TOOLSDIR)/set64bitConst.sh'
800    fi
801    
802  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
803    
# Line 482  echo "  getting package dependency info Line 836  echo "  getting package dependency info
836  #  Strip the comments and then convert the dependency file into  #  Strip the comments and then convert the dependency file into
837  #  two arrays: PNAME, DNAME  #  two arrays: PNAME, DNAME
838  cat $PDEPEND | sed -e 's/#.*$//g' \  cat $PDEPEND | sed -e 's/#.*$//g' \
839      | awk 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \      | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
840      > ./.pd_tmp      > ./.pd_tmp
841  RETVAL=$?  RETVAL=$?
842  if test ! "x${RETVAL}" = x0 ; then  if test ! "x${RETVAL}" = x0 ; then
# Line 492  fi Line 846  fi
846  source ./.pd_tmp  source ./.pd_tmp
847  rm -f ./.pd_tmp  rm -f ./.pd_tmp
848    
849    #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
850    #  file should eventually be added so that, for convenience, one can
851    #  specify groups of packages using names like "ocean" and "atmosphere".
852  echo  -n "  checking default package list:  "  echo  -n "  checking default package list:  "
853  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
854        for i in "." $MODS ; do
855            if test -r $i"/packages.conf" ; then
856                    PDEFAULT=$i"/packages.conf"
857                    break
858            fi
859        done
860    fi
861    if test "x${PDEFAULT}" = x ; then
862      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
863  fi  fi
864  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
# Line 505  else Line 870  else
870      else      else
871          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "  using PDEFAULT=\"$PDEFAULT\""
872          #  Strip the comments and add all the names          #  Strip the comments and add all the names
873          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | awk '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
874          RETVAL=$?          RETVAL=$?
875          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
876              echo -n "Error: can't parse default package list "              echo -n "Error: can't parse default package list "
# Line 515  else Line 880  else
880          for i in $def ; do          for i in $def ; do
881              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
882          done          done
883          echo "    packages are:  $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
884            expand_pkg_groups
885            echo "    after group expansion packages are:  $PACKAGES"
886      fi      fi
887  fi  fi
888    
# Line 534  for p in $PACKAGES ; do Line 901  for p in $PACKAGES ; do
901  done  done
902  PACKAGES="$pack"  PACKAGES="$pack"
903  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
904  rm -f ./.tmp_pack  echo "" > ./.tmp_pack
905  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
906  for i in $PACKAGES ; do  for i in $PACKAGES ; do
907      if test ! -d "$ROOTDIR/pkg/$i" ; then      if test ! -d "$ROOTDIR/pkg/$i" ; then
# Line 625  for i in $PACKAGES ; do Line 992  for i in $PACKAGES ; do
992      if test -d $adr ; then      if test -d $adr ; then
993          SOURCEDIRS="$SOURCEDIRS $adr"          SOURCEDIRS="$SOURCEDIRS $adr"
994          INCLUDEDIRS="$INCLUDEDIRS $adr"          INCLUDEDIRS="$INCLUDEDIRS $adr"
995            if test "x$i" = xautodiff ; then
996                AUTODIFF_PKG_USED=t
997            fi
998      else      else
999          echo "Error: the directory \"$adr\" for package $i doesn't exist"          echo "Error: the directory \"$adr\" for package $i doesn't exist"
1000          exit 1          exit 1
1001      fi      fi
1002  done  done
1003    
 #  This is compatible with the old genmake.  The "DISABLE_*" flags  
 #  need to be replaced by the "ALLOW_*" flags set below.  
 #  
 # echo -n "  Setting package-specific CPP flags:  "  
 # pkrm=( mom_fluxform mom_vecinv generic_advdiff )  
 # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )  
 # echo -n "  "  
 # i=0  
 # while test $i -lt "${#pkrm[@]}" ; do  
 #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1  
 #     RETVAL=$?  
 #     if test "x$RETVAL" = x1 ; then  
 #       DEFINES="$DEFINES ${pkdef[$i]}"  
 #       echo -n " ${pkdef[$i]}"  
 #     fi  
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
1004    
1005  echo "  Setting package-specific CPP flags in CPP_OPTIONS.h:"  # Create a list of #define and #undef to enable/disable packages
1006  CPP_OPTIONS=  PACKAGES_DOT_H=PACKAGES_CONFIG.h
1007  spaths="$SOURCEDIRS"  cat <<EOF >$PACKAGES_DOT_H".tmp"
 for i in $spaths ; do  
     try="$i/CPP_OPTIONS.h"  
     #  echo -n "    trying $try : "  
     if test -f $try -a -r $try ; then  
         echo "    found CPP_OPTIONS=\"$try\""  
         CPP_OPTIONS="$try"  
         if test "x$i" != "x." ; then  
             cp -f $CPP_OPTIONS .  
         fi  
         break  
     fi  
 done  
 if test "x$CPP_OPTIONS" = x ; then  
     echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"  
     exit 1  
 fi  
 if test -e CPP_OPTIONS.h ; then  
     if test ! -e CPP_OPTIONS.h.bak ; then  
         cp -f CPP_OPTIONS.h CPP_OPTIONS.h.bak  
     fi  
     cat CPP_OPTIONS.h \  
         | awk 'BEGIN{p=1;} ($1=="C===" && $2=="GENMAKE"){p=0;} {if (p==1) print $0}' \  
         > CPP_OPTIONS.h.tmp  
 fi  
 cat <<EOF >>CPP_OPTIONS.h.tmp  
1008  C=== GENMAKE v2 ===  C=== GENMAKE v2 ===
1009  C  The following defines have been set by GENMAKE, so please edit  C  The following defines have been set by GENMAKE, so please do not
1010  C  them only if you know what you're doing.  In general, you should  C  edit anything below these comments.  In general, you should
1011  C  add or remove packages by re-running genmake with different  C  add or remove packages by re-running genmake with different
1012  C  "-enable" and/or "-disable" options.  C  "-enable" and/or "-disable" options.
1013    
1014    #ifndef PACKAGES_H
1015    #define PACKAGES_H
1016    
1017  C  Packages disabled by genmake:  C  Packages disabled by genmake:
1018  EOF  EOF
1019  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 702  for n in $names ; do Line 1032  for n in $names ; do
1032              fi              fi
1033          done          done
1034          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1035              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1036              echo "#undef $undef" >> CPP_OPTIONS.h.tmp              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 generic_advdiff)  
                     DEFINES="$DEFINES -DDISABLE_GENERIC_ADVDIFF"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1037          fi          fi
1038      fi      fi
1039  done  done
1040  cat <<EOF >>CPP_OPTIONS.h.tmp  cat <<EOF >>$PACKAGES_DOT_H".tmp"
1041    
1042  C  Packages enabled by genmake:  C  Packages enabled by genmake:
1043  EOF  EOF
1044  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1045      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1046      echo "#define $def" >> CPP_OPTIONS.h.tmp      echo "#define $def" >> $PACKAGES_DOT_H".tmp"
1047    #eh3 DEFINES="$DEFINES -D$def"
1048    
1049  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1050      case $i in      case $i in
1051          aim_v23)          aim_v23)
1052              echo "#define   ALLOW_AIM" >> CPP_OPTIONS.h.tmp              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"
1053                DEFINES="$DEFINES -DALLOW_AIM"
1054                echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"
1055              ;;              ;;
1056      esac      esac
1057  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1058    
1059  done  done
1060  mv -f CPP_OPTIONS.h.tmp CPP_OPTIONS.h  cat <<EOF >>$PACKAGES_DOT_H".tmp"
1061    
1062    #endif /* PACKAGES_H */
1063    EOF
1064    
1065    if test ! -f $PACKAGES_DOT_H ; then
1066        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1067    else
1068        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1069        RETVAL=$?
1070        if test "x$RETVAL" = x0 ; then
1071            rm -f $PACKAGES_DOT_H".tmp"
1072        else
1073            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1074            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1075        fi
1076    fi
1077    
1078  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1079  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1080  STANDARDDIRS=${STANDARDDIRS:-"eesupp model"}  if test "x$STANDARDDIRS" = x ; then
1081        STANDARDDIRS="eesupp model"
1082    fi
1083  for d in $STANDARDDIRS ; do  for d in $STANDARDDIRS ; do
1084      adr="$ROOTDIR/$d/src"      adr="$ROOTDIR/$d/src"
1085      if test ! -d $adr ; then      if test ! -d $adr ; then
# Line 766  for d in $STANDARDDIRS ; do Line 1099  for d in $STANDARDDIRS ; do
1099      fi      fi
1100  done  done
1101    
1102    echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"
1103    echo "    of \"#define ALLOW_PKGNAME\"-type statements:"
1104    CPP_OPTIONS=
1105    spaths=". $INCLUDEDIRS"
1106    for i in $spaths ; do
1107        try="$i/CPP_OPTIONS.h"
1108        #  echo -n "    trying $try : "
1109        if test -f $try -a -r $try ; then
1110            echo "    found CPP_OPTIONS=\"$try\""
1111            CPP_OPTIONS="$try"
1112            break
1113        fi
1114    done
1115    if test "x$CPP_OPTIONS" = x ; then
1116        echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1117        exit 1
1118    fi
1119    # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1120    names=`ls -1 "$ROOTDIR/pkg"`
1121    for n in $names ; do
1122        test_for_package_in_cpp_options $CPP_OPTIONS $n
1123    done
1124    
1125    
1126    #  Here, we build the list of files to be "run through" the adjoint
1127    #  compiler.
1128    if test -f ./ad_files ; then
1129        rm -f ./ad_files
1130    fi
1131    echo "  Creating the list of files for the adjoint compiler."
1132    for i in $SOURCEDIRS ; do
1133        list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1134        for j in $list_files ; do
1135            cat $i/$j >> ad_files
1136        done
1137    done
1138    
1139    cat <<EOF > adjoint_sed
1140    s/call adopen(/call adopen ( mythid,\\
1141         \&           /g
1142    s/call adclose(/call adclose( mythid,\\
1143         \&           /g
1144    s/call adread(/call adread ( mythid,\\
1145         \&           /g
1146    s/call adwrite(/call adwrite( mythid,\\
1147         \&           /g
1148    
1149    EOF
1150    
1151  echo  echo
1152  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1153  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1154  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1155      if test -d $i ; then      if ! test -d $i ; then
1156          INCLUDES="$INCLUDES -I$i"  #       INCLUDES="$INCLUDES -I$i"
1157      else  #   else
1158          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1159      fi      fi
1160  done  done
# Line 787  echo -n 'SRCFILES = '    > srclist.inc Line 1168  echo -n 'SRCFILES = '    > srclist.inc
1168  echo -n 'CSRCFILES = '   > csrclist.inc  echo -n 'CSRCFILES = '   > csrclist.inc
1169  echo -n 'F90SRCFILES = ' > f90srclist.inc  echo -n 'F90SRCFILES = ' > f90srclist.inc
1170  echo -n 'HEADERFILES = ' > hlist.inc  echo -n 'HEADERFILES = ' > hlist.inc
1171  alldirs=". $SOURCEDIRS $INCLUDEDIRS"  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc
1172    alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1173  for d in $alldirs ; do  for d in $alldirs ; do
1174      deplist=      deplist=
1175      sfiles=`( cd $d; echo *.[h,c,F] )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1176      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1177      for sf in $sfiles ; do      for sf in $sfiles ; do
1178          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1179              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1180                  extn=`echo $sf | awk -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
1181                  touch .links.tmp/$sf                  touch .links.tmp/$sf
1182                  deplist="$deplist $sf"                  deplist="$deplist $sf"
1183                  case $extn in                  case $extn in
# Line 815  for d in $alldirs ; do Line 1197  for d in $alldirs ; do
1197                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1198                          echo -n " $sf" >> hlist.inc                          echo -n " $sf" >> hlist.inc
1199                          ;;                          ;;
1200                        flow)
1201                            echo    " \\"  >> ad_flow_files.inc
1202                            echo -n " $sf" >> ad_flow_files.inc
1203                            ;;
1204                  esac                  esac
1205              fi              fi
1206          fi          fi
# Line 831  echo "" >> srclist.inc Line 1217  echo "" >> srclist.inc
1217  echo "" >> csrclist.inc  echo "" >> csrclist.inc
1218  echo "" >> f90srclist.inc  echo "" >> f90srclist.inc
1219  echo "" >> hlist.inc  echo "" >> hlist.inc
1220    echo "" >> ad_flow_files.inc
1221    
1222  if test -e $MAKEFILE ; then  if test -e $MAKEFILE ; then
1223      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
# Line 844  echo "# by the command:" >> $MAKEFILE Line 1231  echo "# by the command:" >> $MAKEFILE
1231  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $@" >> $MAKEFILE
1232  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1233  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1234    
1235    EXE_AD=$EXECUTABLE"_ad"
1236    EXE_FTL=$EXECUTABLE"_ftl"
1237    EXE_SVD=$EXECUTABLE"_svd"
1238    
1239  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1240  #  #
1241  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
# Line 872  EXEDIR      = ${EXEDIR} Line 1264  EXEDIR      = ${EXEDIR}
1264  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}
1265  TOOLSDIR    = ${TOOLSDIR}  TOOLSDIR    = ${TOOLSDIR}
1266    
1267    #eh3  new defines for the adjoint work
1268    AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1269    EXE_AD      = ${EXE_AD}
1270    EXE_FTL     = ${EXE_FTL}
1271    EXE_SVD     = ${EXE_SVD}
1272    
1273  EOF  EOF
1274    
1275  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 917  MAKEFILE=${MAKEFILE} Line 1315  MAKEFILE=${MAKEFILE}
1315    
1316  EOF  EOF
1317    
1318  cat srclist.inc    >> $MAKEFILE  cat srclist.inc       >> $MAKEFILE
1319  cat csrclist.inc   >> $MAKEFILE  cat csrclist.inc      >> $MAKEFILE
1320  cat f90srclist.inc >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1321  cat hlist.inc      >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1322    cat ad_flow_files.inc >> $MAKEFILE
1323    echo               >> $MAKEFILE
1324  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE
1325  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE
1326  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1327    
1328  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1329    rm -f ad_flow_files.inc
1330    
1331  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1332    
# Line 938  all: \$(EXECUTABLE) Line 1339  all: \$(EXECUTABLE)
1339  depend:  depend:
1340          @make links          @make links
1341          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1342          ../../../tools/f90mkdepend >> \$(MAKEFILE)          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)
1343    
1344  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)
1345    
# Line 949  output.txt: \$(EXECUTABLE) Line 1350  output.txt: \$(EXECUTABLE)
1350          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1351    
1352  clean:  clean:
1353            -cat AD_CONFIG.template > AD_CONFIG.h
1354          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}
1355  Clean:  Clean:
1356          @make clean          @make clean
1357          @make cleanlinks          @make cleanlinks
1358          -rm -f Makefile.bak          -rm -f Makefile.bak genmake_state genmake_*optfile make.log
1359  CLEAN:  CLEAN:
1360          @make Clean          @make Clean
1361          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1362          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1363          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1364          -rm -f \$(EXECUTABLE)          -rm -f \$(EXECUTABLE) output.txt
1365    
1366    #eh3 Makefile: makefile
1367  makefile:  makefile:
1368          ${0} $@          ${0} $@
1369  cleanlinks:  cleanlinks:
# Line 984  cleanlinks: Line 1387  cleanlinks:
1387  .p.f:  .p.f:
1388          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1389    
1390    #=========================================
1391    #===  Automatic Differentiation Rules  ===
1392    
1393    TAMC           = ${TAMC}
1394    TAF            = ${TAF}
1395    
1396    TAF_EXTRA      = ${TAF_EXTRA}
1397    TAMC_EXTRA     = ${TAMC_EXTRA}
1398    
1399    EOF
1400    
1401    ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
1402    ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
1403    ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1404    for i in $ad_vars ; do
1405        name=$i
1406        t1="t2=\$"`echo $i`
1407        eval $t1
1408        printf "%-20s = " $name >> $MAKEFILE
1409        echo $t2 >> $MAKEFILE
1410    done
1411    
1412    echo "  Add the source list for AD code generation"
1413    echo >> $MAKEFILE
1414    echo -n "AD_FILES = " >> $MAKEFILE
1415    AD_FILES=`cat ad_files`
1416    for i in $AD_FILES ; do
1417        echo    " \\" >> $MAKEFILE
1418        echo -n " $i" >> $MAKEFILE
1419    done
1420    echo >> $MAKEFILE
1421    rm -f ad_files
1422    
1423    cat >>$MAKEFILE <<EOF
1424    
1425    # ... AD ...
1426    adall: ad_taf
1427    adtaf: ad_taf_output.f
1428    adtamc: ad_tamc_output.f
1429    
1430    ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1431            cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1432            @make \$(F77FILES)
1433            @make \$(AD_FLOW_FILES)
1434            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1435    
1436    ad_taf_output.f: ad_input_code.f
1437            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1438            cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f
1439    
1440    ad_taf: ad_taf_output.o \$(OBJFILES)
1441            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1442    
1443    ad_tamc_output.f: ad_input_code.f
1444            \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1445            cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f
1446    
1447    ad_tamc: ad_tamc_output.o \$(OBJFILES)
1448            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
1449    
1450    
1451    # ... FTL ...
1452    ftlall: ftl_taf
1453    ftltaf: ftl_taf_output.f
1454    ftltamc: ftl_tamc_output.f
1455    
1456    ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1457            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1458            @make \$(F77FILES)
1459            @make \$(AD_FLOW_FILES)
1460            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1461    
1462    ftl_taf_output.f: ftl_input_code.f
1463            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1464            cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f
1465    
1466    ftl_taf: ftl_taf_output.o \$(OBJFILES)
1467            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1468    
1469    ftl_tamc_output.f: ftl_input_code.f
1470            \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1471            cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f
1472    
1473    ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1474            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1475    
1476    
1477    # ... SVD ...
1478    svd: svd_taf
1479    svd_taf_f: svd_taf_output.f
1480    
1481    svd_input_code.f: \$(SRCFILES)
1482            cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h
1483            @make \$(F77FILES)
1484            @make \$(AD_FLOW_FILES)
1485            cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f
1486    
1487    svd_taf_output.f: svd_input_code.f
1488            \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f
1489            cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f
1490    
1491    svd_taf: svd_taf_output.o \$(OBJFILES)
1492            \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)
1493    
1494    
1495    #=========================================
1496    
1497  EOF  EOF
1498    
1499    if test "x$EXEHOOK" != x ; then
1500        printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
1501    fi
1502    
1503  echo "  Making list of \"exceptions\" that need \".p\" files"  echo "  Making list of \"exceptions\" that need \".p\" files"
1504  for i in $KPPFILES ; do  for i in $KPPFILES ; do
1505      base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`      base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
# Line 1016  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1530  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1530    
1531  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1532    
1533    #  Write the "template" files for the adjoint builds
1534    cat >AD_CONFIG.template <<EOF
1535    C  WARNING: This file is automatically generated by genmake2 and
1536    C    used by the Makefile rules.  Please DO NOT EDIT this file
1537    C    unless you are CERTAIN that you know what you are doing.
1538    
1539    #undef ALLOW_ADJOINT_RUN
1540    #undef ALLOW_TANGENTLINEAR_RUN
1541    #undef ALLOW_ECCO_OPTIMIZATION
1542    EOF
1543    cat >ad_config.template <<EOF
1544    C  WARNING: This file is automatically generated by genmake2 and
1545    C    used by the Makefile rules.  Please DO NOT EDIT this file
1546    C    unless you are CERTAIN that you know what you are doing.
1547    
1548    #define ALLOW_ADJOINT_RUN
1549    #undef ALLOW_TANGENTLINEAR_RUN
1550    #undef ALLOW_ECCO_OPTIMIZATION
1551    EOF
1552    cat >ftl_config.template <<EOF
1553    C  WARNING: This file is automatically generated by genmake2 and
1554    C    used by the Makefile rules.  Please DO NOT EDIT this file
1555    C    unless you are CERTAIN that you know what you are doing.
1556    
1557    #undef ALLOW_ADJOINT_RUN
1558    #define ALLOW_TANGENTLINEAR_RUN
1559    #undef ALLOW_ECCO_OPTIMIZATION
1560    EOF
1561    cat >svd_config.template <<EOF
1562    C  WARNING: This file is automatically generated by genmake2 and
1563    C    used by the Makefile rules.  Please DO NOT EDIT this file
1564    C    unless you are CERTAIN that you know what you are doing.
1565    
1566    #undef ALLOW_ADJOINT_RUN
1567    #undef ALLOW_TANGENTLINEAR_RUN
1568    #undef ALLOW_ECCO_OPTIMIZATION
1569    EOF
1570    cp AD_CONFIG.template AD_CONFIG.h
1571    
1572    
1573  #  Write the "state" for future records  #  Write the "state" for future records
1574  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
1575      echo -n "" > gm_state      echo -n "" > genmake_state
1576      for i in $gm_state ; do      for i in $gm_state ; do
1577          t1="t2=\$$i"          t1="t2=\$$i"
1578          eval $t1          eval $t1
1579          echo "$i='$t2'" >> gm_state          echo "$i='$t2'" >> genmake_state
1580      done      done
1581  fi  fi

Legend:
Removed from v.1.5  
changed lines
  Added in v.1.30

  ViewVC Help
Powered by ViewVC 1.1.22